#include <catch2/catch_test_macros.hpp>
#include "opencv2/core.hpp"
#include <opencv2/imgcodecs.hpp>
#include <memory>
#include <iostream>

#include "aidge/backend/opencv/stimuli/StimuliImpl_opencv_imread.hpp"
#include "aidge/backend/opencv/data/TensorImpl.hpp"
#include "aidge/data/Tensor.hpp"


using namespace Aidge;

TEST_CASE("StimuliImpl_opencv_imread creation", "[StimuliImpl_opencv_imread][OpenCV]") {
    SECTION("Instanciation & load an image") {
        //  Load image with imread
        // cv::Mat true_mat = cv::imread("/data1/is156025/tb256203/dev/eclipse_aidge/aidge/user_tests/Lenna.png");
        cv::Mat true_mat = cv::imread("/data1/is156025/tb256203/dev/eclipse_aidge/aidge/user_tests/train-images-idx3-ubyte[00001].pgm");
        REQUIRE(true_mat.empty()==false);

        // Create StimuliImpl_opencv_imread
        // StimuliImpl_opencv_imread stImpl("/data1/is156025/tb256203/dev/eclipse_aidge/aidge/user_tests/Lenna.png");
        StimuliImpl_opencv_imread stImpl("/data1/is156025/tb256203/dev/eclipse_aidge/aidge/user_tests/train-images-idx3-ubyte[00001].pgm");
        std::shared_ptr<Tensor> tensor_load;
        tensor_load = stImpl.load();
        
        // Access the cv::Mat with the tensor
        TensorImpl_opencv_* tImpl_opencv = dynamic_cast<TensorImpl_opencv_*>(tensor_load->getImpl().get());

        REQUIRE(tImpl_opencv->getCvMat().size() == true_mat.size());
        REQUIRE(cv::countNonZero(tImpl_opencv->getCvMat() != true_mat) == 0);

    }
}
